package l09_threads;

import java.util.Timer;
import java.util.TimerTask;

//	Schedule a task that executes once every second.

public class AnnoyingBeep {

	private static double d = 1;

	public static void startTimer(int n) {
		Timer timer = new Timer(true);
		timer.schedule(new RemindTask(n), // TimerTask
			0,		//initial delay
			1000);	//subsequent rate
	}

	static class RemindTask extends TimerTask {
		int numWarningBeeps;

		public RemindTask(int n) {
			numWarningBeeps = n;
		}

		@Override
		public void run() {
			if (numWarningBeeps > 0) {
				System.out.format("Beep %d! d = %e%n", numWarningBeeps, d);
				numWarningBeeps--;
			} else {
				System.out.format("Time's up!%n");
				System.exit(0);	//	Stops the thread (and everything else)
			}
		}
	}

	public static void main(String[] args) {
		int n = (args.length > 0) ? Integer.parseInt(args[0]) : 3;
		AnnoyingBeep.startTimer(n);
		System.out.format("Task scheduled.%n");
		while(true) d /= 1.0000001;
	}
}

