package l09_threads;

//	A "daemon" thread is one that is supposed to provide a general service in the
//	background as long as the program is running, but is not part of the essence of
//	the program. Thus, when all the non-daemon threads complete, the program is
//	terminated. Conversely, if there are any non-daemon threads still running, the
//	program doesn't terminate. There is, for instance, a non-daemon thread that runs
//	main().

import utilities.ThreadHelperMethods;

public class SimpleDaemons extends Thread {
	public SimpleDaemons() {

//	You must set the thread to be a daemon by calling setDaemon() before it is
//	started. Once the threads are all started, the program terminates immediately,
//	before any threads can print themselves, because there are no non-daemon threads
//	(other than main()) holding the program open. Thus, the program terminates
//	without printing any output.

//		setDaemon(true); // Must be called before start()
		start();
	}

	@Override
	public void run() {
		while(true) {
			ThreadHelperMethods.safeSleep(1000);
			System.out.println("Thread " + getName() + " running");
		}
	}

	public static void main(String[] args) {
		for(int i = 0; i < 10; i++)
			new SimpleDaemons();
		System.out.println("End of main");
	}
}

