package l09_threads;

/*
	The following class terminates the program by subclassing the standard library
	Timer class: The delay is in milliseconds, and the message will be printed if
	the timeout expires. Note that by calling super(true), this is created as a
	daemon thread so that if the program completes in some other way, this thread
	will not prevent it from exiting. The Timer.schedule() method is given a
	TimerTask subclass (created here as an anonymous inner class) whose run() is
	executed after the second schedule() argument delay (in milliseconds) runs out.

	public abstract class TimerTask implements Runnable

	public class Timer
	Timer(boolean isDaemon)
		Creates a new timer whose associated thread may be specified to run as a daemon.
		public void schedule(TimerTask task, long delay)

	public abstract class TimerTask implements Runnable
*/

import java.util.Timer;
import java.util.TimerTask;

public class Timeout extends Timer {
	public Timeout(int delay, long startTime, final String msg) {
		super(true); // Daemon thread
		schedule(new TimerTask() {
			@Override
			public void run() {
				System.out.println(msg + " at " + (System.nanoTime() - startTime) / 1000000 + " [ms]");
				System.exit(0);
			}
		}, delay);
	}
}

